#! /usr/bin/env python
# encoding: utf-8

"""
Wrap code in a template and execute it within a Python interpreter.
"""

import subprocess
import sys


TEMPLATE = u"""\
# encoding: utf-8

import traceback

try:
    # Requires that included string is indented correctly.
%s
# Catching `Exception` usually is bad style.
except Exception:
    print
    traceback.print_exc()
finally:
    print
    print u"[Eingabe] drücken:",
    raw_input(u"")
"""

EXAMPLE_FILENAME = u"temp.py"

DEFAULT_ENCODING = u"UTF-8"


def main():
    """See module docsting."""
    # Read lines from standard input.
    text = sys.stdin.read().decode(DEFAULT_ENCODING)
    # Put text into template.
    script = TEMPLATE % text
    # Write script to temporary file.
    with open(EXAMPLE_FILENAME, 'w') as fobj:
        fobj.write(script.encode(DEFAULT_ENCODING))
    # Execute the script.
    subprocess.call([u"gnome-terminal",
                     u"--window-with-profile=Talk",
                     u"--geometry=80x40",
                     u"-x", u"python", EXAMPLE_FILENAME])


if __name__ == '__main__':
    main()

